require 'active_record/observer'
module ActAsCached
  module ActiveRecord
    class Actobserver < ::ActiveRecord::Observer
      cattr_accessor :observed_classes
      @@observed_classes = []

      def after_commit(object)
        expire_cache(object)
      end

      private
      def expire_cache(object)
        object.cache_store.delete_matched(%r(#{match_keys(object)}),namespace: object.cache_prefix)
      end

      def match_keys(object)
        ["all","first","last",object.to_param,nil].collect{|x| [object.cache_name,x].compact.join("/")}.join("|") << "$"
      end
    end
  end
end