module ActAsCached
  module ActiveRecord
    module HasManyThroughAssociation
      def self.included(klass)
        klass.class_eval do
          alias_method_chain :find_target,:act_as_cache
        end
      end

      def find_target_with_act_as_cache
        enabled_cache? ?
        fetch_cache(cache_path) { find_target_without_act_as_cache } :
        find_target_without_act_as_cache
      end
    end
  end
end