module ActAsCached
  module CacheOptions
    def self.included(klass)
      klass.send(:extend,ClassMethods)
    end

    module ClassMethods
      def options
        @options ||= cache_options.extract_options!
      end

      def name
        @name ||= klass.name
      end

      def prefix
        options[:prefix] || ActAsCached.prefix
      end

      def store
        options[:cache_store] || ActAsCached.cache_store
      end

      def logger
        options[:logger] || ActAsCached.logger
      end

      def time
        options[:expires_time] || ActAsCached.expires_time
      end
    end
  end
end