module ActAsCached
  module Helpers
    def write_cache(name)
      store.write(name,yield,expires_in: time,namespace: prefix)
      read_cache(name)
    end

    def read_cache(name)
      store.read(name,namespace: prefix)
    end

    def fetch_cache(name,&block)
      read_cache(name) || write_cache(name) { yield }
    end

    def enabled_cache?
      true
    end
  end
end