module ActAsCached
  def self.hook_config!
    ActAsCached.configure do
      config.logger       ||= ::Rails.logger
      config.cache_store  ||= ::Rails.cache
      config.expires_time ||= 1.week
      config.prefix       ||= 'aac'
    end
  end
  
  def self.hook_rails!
    if defined?(::ActiveRecord)
      require 'act_as_cached/active_record'
      ::ActiveRecord::Base.send(:include,Mixin)
    end
  end

  class Rails < ::Rails::Engine
    config.active_record.observers = "act_as_cached/active_record/actobserver"
    config.act_as_cache = ActAsCached
    
    config.before_initialize do
      ActAsCached.hook_config!
      ActAsCached.hook_rails!
    end
    
  end if defined?(::Rails)
end